---
apiVersion: v1
kind: Namespace
metadata:
  name: {{K8S_NAMESPACE}}-maintenance
  labels:
    app.kubernetes.io/component: namespace
---
apiVersion: v1
kind: ConfigMap
metadata:
  name: caddy-maintenance-config
  namespace: {{K8S_NAMESPACE}}-maintenance
data:
  # Remove the Host header otherwise the S3 bucket's server
  # will use it as it's own.
  Caddyfile: |
    :{$DEFAULT_SITE_PORT} {
      rewrite * /maintenance-mode.html
      reverse_proxy {$S3_BUCKET_URL} {
         header_up -Host
      }
    }
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: caddy-maintenance
  namespace: {{K8S_NAMESPACE}}-maintenance
  labels:
    app.kubernetes.io/name: caddy-maintenance
spec:
  selector:
    matchLabels:
      app.kubernetes.io/name: caddy-maintenance
  template:
    metadata:
      labels:
        app.kubernetes.io/name: caddy-maintenance
    spec:
      containers:
        - name: caddy-maintenance
          image: {{ DOCKER_IMAGE_CADDY }}
          env:
          - name: DEFAULT_SITE_PORT
            value: "{{CADDY_HTTP_PORT}}"
          - name: S3_BUCKET_URL
            value: "{{GROVE_MAINTENANCE_S3_BUCKET_ROOT_URL}}"
          volumeMounts:
            - mountPath: /etc/caddy/
              name: caddy-maintenance-config
          ports:
            - containerPort: {{CADDY_HTTP_PORT}}
      volumes:
        - name: caddy-maintenance-config
          configMap:
            name: caddy-maintenance-config
---
apiVersion: v1
kind: Service
metadata:
  name: caddy-maintenance
  namespace: {{K8S_NAMESPACE}}-maintenance
  labels:
    app.kubernetes.io/name: caddy-maintenance
spec:
  type: ClusterIP
  ports:
    - port: {{ CADDY_HTTP_PORT }}
      name: http
  selector:
    app.kubernetes.io/name: caddy-maintenance
---
{%- set hosts = [LMS_HOST, PREVIEW_LMS_HOST, CMS_HOST] %}
{%- set tmp = hosts.append(MFE_HOST) if MFE_HOST is defined %}
{%- set tmp = hosts.append(ECOMMERCE_HOST) if ECOMMERCE_HOST is defined %}
{%- set tmp = hosts.append(DISCOVERY_HOST) if DISCOVERY_HOST is defined %}
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
    name: {{K8S_NAMESPACE}}-maintenance-ingress
    namespace: {{K8S_NAMESPACE}}-maintenance
    annotations:
      {% if ENABLE_HTTPS %}cert-manager.io/issuer: letsencrypt{% endif %}
spec:
  ingressClassName: nginx
  rules:
  {% for host in hosts|select %}
  - host: {{ host }}
    http:
      paths:
        - pathType: Prefix
          path: "/"
          backend:
            service:
              name: caddy-maintenance
              port:
                number: {{CADDY_HTTP_PORT}}{% endfor %}
  {% if ENABLE_HTTPS %}
  tls:
  - hosts:
      {% for host in hosts|select %}
      - {{ host }}{% endfor %}
    secretName: {{ K8S_NAMESPACE }}-tls-secret
  {%endif%}
